#include <stdio.h>
#include <stdlib.h>
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <tiffio.h>

int
main(int argc, char ** argv)
{
	FILE *tifheader1 = fopen(argv[1], "r");
	FILE *tifheader2 = fopen(argv[2], "r");

	if(tifheader1 == NULL) return -1;
	if(tifheader2 == NULL) return -1;

	int width1, height1, xoffset1, yoffset1;
	int width2, height2, xoffset2, yoffset2;
	char tifname1[512]; char class1[512]; char depth1[512]; char dimensions1[512]; char size1[512];
	char tifname2[512]; char class2[512]; char depth2[512]; char dimensions2[512]; char size2[512];
	fscanf(tifheader1, "%s TIFF %s %dx%d+%d+%d %s %s %s\n", tifname1, dimensions1, &width1, &height1, &xoffset1, &yoffset1, class1, depth1, size1);
	fscanf(tifheader2, "%s TIFF %s %dx%d+%d+%d %s %s %s\n", tifname2, dimensions2, &width2, &height2, &xoffset2, &yoffset2, class2, depth2, size2);
	fprintf(stdout, "Image 1 {%dx%d} +%d+%d\n", width1, height1, xoffset1, yoffset1);
	fprintf(stdout, "Image 2 {%dx%d} +%d+%d\n", width2, height2, xoffset2, yoffset2);
	
  IplImage* warpedimg1 = cvLoadImage(argv[3], CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR);
  IplImage* warpedimg2 = cvLoadImage(argv[4], CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR);
  IplImage* rawimg1 = cvLoadImage(argv[5], CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR);
  IplImage* rawimg2 = cvLoadImage(argv[6], CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR);
  
	fprintf(stdout, "Channels %d. Alpha %d. Depth %d.", warpedimg1->nChannels, warpedimg1->alphaChannel, warpedimg1->depth);
	
	int fullwidth =  MAX(warpedimg1->width + xoffset1, warpedimg2->width + xoffset2);
	int fullheight = MAX(warpedimg1->height + yoffset1, warpedimg2->height + yoffset2);
	
	fprintf(stdout, "Full canvas {%dx%d}\n", fullwidth, fullheight);

	IplImage* fullimg1 = cvCreateImage( cvSize(fullwidth, fullheight), IPL_DEPTH_8U, 3);
	IplImage* fullimg2 = cvCreateImage( cvSize(fullwidth, fullheight), IPL_DEPTH_8U, 3);
	IplImage* fullimg = cvCreateImage( cvSize(fullwidth, fullheight), IPL_DEPTH_8U, 3);

	cvSetImageROI( fullimg1, cvRect( xoffset1, yoffset1, warpedimg1->width, warpedimg1->height));
	cvCopy(warpedimg1, fullimg1);
	cvResetImageROI( fullimg1 );
	cvSetImageROI( fullimg2, cvRect( xoffset2, yoffset2, warpedimg2->width, warpedimg2->height));
	cvCopy(warpedimg2, fullimg2);
	cvResetImageROI( fullimg2 );

	int w = fullimg1->width;
	int widthStep = fullimg1->widthStep;
	int h = fullimg1->height;

	float r_gain = 0.0; float g_gain = 0.0; float b_gain = 0.0;
	float r_gain1 = 0.0; float g_gain1 = 0.0; float b_gain1 = 0.0;
	float r_gain2 = 0.0; float g_gain2 = 0.0; float b_gain2 = 0.0;

	int count    = 0;
	for(int j = 0; j < h; j++)
	for(int i = 0; i < w; i++)
	{
		unsigned char R1 = (unsigned char)(fullimg1->imageData[j*widthStep + i*3]);
		unsigned char G1 = (unsigned char)(fullimg1->imageData[j*widthStep + i*3 + 1]);
		unsigned char B1 = (unsigned char)(fullimg1->imageData[j*widthStep + i*3 + 2]);
		unsigned char R2 = (unsigned char)(fullimg2->imageData[j*widthStep + i*3]);
		unsigned char G2 = (unsigned char)(fullimg2->imageData[j*widthStep + i*3 + 1]);
		unsigned char B2 = (unsigned char)(fullimg2->imageData[j*widthStep + i*3 + 2]);
		if(	R1 > 10 && R1 != 255 && 
				G1 > 10 && G1 != 255 && 
				B1 > 10 && B1 != 255 && 
				R2 > 10 && R2 != 255 && 
				G2 > 10 && G2 != 255 && 
				B2 > 10 && B2 != 255) 
		{
			count++;
			r_gain += (float)R2 / (float)R1;
			g_gain += (float)G2 / (float)G1;
			b_gain += (float)B2 / (float)B1;
		}
	}
	if(count != 0)
	{
		r_gain = r_gain/(float)count;
		g_gain = g_gain/(float)count;
		b_gain = b_gain/(float)count;
                r_gain = 0.5*(r_gain-1.0)+1.0;
                g_gain = 0.5*(g_gain-1.0)+1.0;
                b_gain = 0.5*(b_gain-1.0)+1.0;
		r_gain1 = r_gain;
		g_gain1 = g_gain;
		b_gain1 = b_gain;
		r_gain2 = 1.0;
		g_gain2 = 1.0;
		b_gain2 = 1.0;
	} else
	{
		r_gain = 1;
		g_gain = 1;
		b_gain = 1;
	}

	printf("base gains: %f, %f, %f. gains1: %f, %f, %f. gains2: %f, %f, %f.\n", 
			r_gain, g_gain, b_gain,
			r_gain1, g_gain1, b_gain1,
			r_gain2, g_gain2, b_gain2); 

	w = rawimg1->width;
	widthStep = rawimg1->widthStep;
	h = rawimg1->height;
	for(int j = 0; j < h; j++)
	for(int i = 0; i < w; i++)
	{
		unsigned char R1 = (unsigned char)(rawimg1->imageData[j*widthStep + i*3]);
		unsigned char G1 = (unsigned char)(rawimg1->imageData[j*widthStep + i*3 + 1]);
		unsigned char B1 = (unsigned char)(rawimg1->imageData[j*widthStep + i*3 + 2]);
		int newR1 = (int)((float)R1*r_gain1);
		int newG1 = (int)((float)G1*g_gain1);
		int newB1 = (int)((float)B1*b_gain1);
		if(newR1 > 255) newR1 = 255;
		if(newG1 > 255) newG1 = 255;
		if(newB1 > 255) newB1 = 255;
		rawimg1->imageData[j*widthStep + i*3] =     newR1; 
		rawimg1->imageData[j*widthStep + i*3 + 1] = newG1;
		rawimg1->imageData[j*widthStep + i*3 + 2] = newB1;
	}

	cvSaveImage(argv[5], rawimg1);

	cvReleaseImage(&rawimg1);
	cvReleaseImage(&rawimg2);
	cvReleaseImage(&warpedimg1);
	cvReleaseImage(&warpedimg2);
	cvReleaseImage(&fullimg1);
	cvReleaseImage(&fullimg2);
	return 0;
}
